/*
 * Copyright (c) 2003 Linuxant inc.
 * Copyright (c) 2001-2003 Conexant Systems, Inc.
 *
 * NOTE: The use and distribution of this software is governed by the terms in
 * the file LICENSE, which is included in the package. You must read this and
 * agree to these terms before using or distributing this software.
 *
 */
#ifndef __OS_DEBUG_H__
#define __OS_DEBUG_H__

#ifdef __cplusplus
extern "C"
{
#endif

#if ( UK_MODE == UK_KERNEL ) && !defined(OS_NOREDEFS)
#undef printk
#define printk          OsDebugPrintf
#define DumpData		OsDebugDumpData
#endif

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(pop)   // Packing compatible with our VXDs
#endif

#include <stdarg.h>

void    OsErrorVPrintf       (const char *szFormat, va_list args);

void    OsErrorPrintf       (const char *szFormat, ...)
	    __attribute__ ((format (printf, 1, 2)));

void    OsDebugVPrintf       (const char *szFormat, va_list args);

void    OsDebugPrintf       (const char *szFormat, ...)
	    __attribute__ ((format (printf, 1, 2)));

void    OsDebugBreakpoint   ( const char *szMsg );

void	OsDebugDumpData(PUINT8 data, UINT32 len);

#ifdef __cplusplus
}
#endif

#endif /* __OS_DEBUG_H__ */
